#include "mpi.h"
#include <unistd.h>
#include <cstdlib>
#include <iostream>
#include <iterator>
#include <vector>
#include <algorithm>
#include "DebuggingTools.h"

using namespace std;

class Master{
private:
    int task_iterator;
    int num_slaves;
    int num_task;
    vector<int> tasks;
    // TODO implement:
    /*
    - Declare private parameters and methods of your master class
    */
public:
    Master(int size);
    void prepare_data();
    // TODO implement:
    /*
    - Declare public parameters and methods of your master class
    */
};

Master::Master(int size)
{
    num_slaves = size-1;
}

void Master::prepare_data() {
    int task_time, final_task;

    // Get number of tasks and final task position
    cout << "Enter number of tasks: ";
    cin >> num_task;
    cout << "Enter final task index: ";
    cin >> final_task;

    // Clip values to prevent segfaults
    num_task = max(1, num_task);
    final_task = max(0, final_task);
    final_task = min(final_task, num_task - 1);

    // Set task iterator to 0
    task_iterator = 0;

    // Generate some random tasks
    for (int i = 0; i < num_task; i++) {
        task_time = (rand() % 10) + 1;
        tasks.push_back(task_time);
    }
    tasks[final_task] = -1;

    // Print master tasks
    std::stringstream result;
    std::copy(tasks.begin(), tasks.end(), std::ostream_iterator<int>(result, " "));
    cout << "Master has tasks: {" << result.str().c_str() << "}" << endl;
}


class Slave{
private:
    int my_rank;
    // TODO implement:
    /*
    - Declare private parameters and methods of your slave class
    */
public:
    Slave(int rank);
    // TODO implement:
    /*
    - Declare public parameters and methods of your slave class
    */
};

Slave::Slave(int rank)
{
    my_rank = rank;
}

int main(int argc, char **argv) {
    int rank;
    int size;

    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    MPI_Comm_size(MPI_COMM_WORLD, &size);
    if (rank == 0) {
        Master master = Master(size);
        master.prepare_data();
        MPI_Barrier( MPI_COMM_WORLD);
        // TODO implement:
        /*
        - Call necessary methods of your master class for correct performance
        */
    } else {
        Slave slave = Slave(rank);
        MPI_Barrier( MPI_COMM_WORLD);
        // TODO implement:
        /*
        - Call necessary methods of your slave class for correct performance
        */
    }

    MPI_Finalize();

    return 0;
}